static               insert(void);
static void          *remove_front(void);
static               read_parameters(void);
static int           comm_init(void);
static REL_TIME      latency(void);
static REL_TIME      broadcast_effect(void);
static int           network_ok_l(void);
static int           network_ok_s(void);
static int           network_ok_l_g(void);
static int           network_ok_s_g(void);
static int           cpu_accepts_l(void);
static int           cpu_accepts_s(void);
static int           scp_accepts_l(void);
static int           scp_accepts_s(void);
static int           always_accept(void);
static int           increase_net_load(void);
static int           decrease_net_load(void);
static int           ge(void);
static void          *create_event_heap(void);
static MSG           *fifo_dequeue(void);
static float         ran1(void);

static int sim_read_parameters(void);
static void simulate(void);
static cpu_event(void);
static recv_cp_event(void);
static recv_cp_deposit(void);
static send_cp_event(void);
static actual_broadcast(void);
static actual_send(void);
static wait_on_network(void);
static wait_on_local(void);
static release_waiting_network(void);
static release_waiting_local(void);
static update_etime(void);
static assign_etime(void);
static update_lower_bound(void);
static advance_clock(void);
static select_processor(void);
static sim_send_message(void);
static become_idle(void);
static make_active(void);
static int sim_initialize(void);
static init_max_time_const(void);
static int error_msg(void);
static relocate_event(void);
static next_event(void);
static SIM_TIME next_msg_arrival(void);
static is_first_element(void);
static fifo_enqueue(void);
static fifo_empty(void);
static float expdev(void);
